{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit DdlgForm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, DualDlg;

type
  TDualDialogForm = class(TForm)
    DualListDialog1: TDualListDialog;
    Panel1: TPanel;
    Ok: TBitBtn;
    Cancel: TBitBtn;
    HelpBtn: TBitBtn;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
  private
    FHelpStr: PString;
    function GetDualList: TDualListDialog;
    procedure SetHelpStr(Value: String);
  public
    property HelpStr: String write SetHelpStr;
    property DualList: TDualListDialog read GetDualList;
  end;

var
  DualDialogForm: TDualDialogForm;

implementation

{$R *.DFM}

uses PrpCtrls, DemoHelp;

function TDualDialogForm.GetDualList: TDualListDialog;
begin
  Result := DualListDialog1;
end;

procedure TDualDialogForm.SetHelpStr(Value: String);
begin
  AssignStr(FHelpStr, Value);
end;

procedure TDualDialogForm.HelpBtnClick(Sender: TObject);
begin
  ShowDemoHelp(FHelpStr^, TRtObjectInspector, True, False, False);
end;

procedure TDualDialogForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F1) and (Shift = []) then HelpBtnClick(Sender);
end;

procedure TDualDialogForm.FormDestroy(Sender: TObject);
begin
  DisposeStr(FHelpStr);
end;

end.





