{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit DemoHelp;

{$B-,G+,I+,N+,P+,R-,S-,T-,W-,X+}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

procedure InitHelp;
procedure FreeHelp;
procedure ShowDemoHelp(const PropName: String; AClass: TClass;
  New, MethodProp, Duplicate: Boolean);

implementation

uses SysUtils, WinTypes, Controls, Forms, Dialogs, IniFiles, DemConst;

const
  BlueCodeHelp: String = '';
  DelphiHelp: String = '';

function GetHelpPath: String;
const
  FileFilter = 'BlueCode-Helpfile|';
var
  HelpPath: array[0..144] of Char;
  Buffer: array[0..22] of Char;
  SearchDlg: TOpenDialog;
  I: Integer;
  P: PChar;
begin
  Result := '';
  StrPCopy(HelpPath, ExtractFilePath(Application.ExeName));
  for I := 0 to 2 do
  begin
    P := StrRScan(HelpPath, '\');
    if P <> nil then P[0] := #0;
  end;
  StrCat(HelpPath, StrPCopy(Buffer, '\' + LoadStr(SHelpDir) + '\' + BlueCodeHelp));
  while not FileExists(StrPas(HelpPath)) or
    (CompareText(ExtractFileName(StrPas(HelpPath)), BlueCodeHelp) <> 0) do
  begin
    if MessageDlg(FmtLoadStr(SInvalidHelpPath, [BlueCodeHelp, BlueCodeHelp]),
      mtConfirmation, mbYesNoCancel, 0) <> mrYes then Exit;
    SearchDlg := TOpenDialog.Create(Application);
    try
      with SearchDlg do
      begin
        Filter := FileFilter + BlueCodeHelp;
        if Execute then StrPCopy(HelpPath, FileName)
        else Exit;
      end;
    finally
      SearchDlg.Free;
    end;
  end;
  Result := StrPas(HelpPath);
end;

procedure InitHelp;
const
  MultiHelpFileName = 'MultiHlp.Ini';
  Section = 'Index Path';
var
  I: TIniFile;
  S: String;
begin
  BlueCodeHelp := LoadStr(SBlueCodeHelp);
  DelphiHelp := LoadStr(SDelphiHelp);
  I := TIniFile.Create(MultiHelpFileName);
  with I do
  begin
    S := ReadString(Section, BlueCodeHelp, BlueCodeHelp);
    if not FileExists(S) then
    begin
      S := GetHelpPath;
      if S <> '' then WriteString(Section, BlueCodeHelp, S);
    end;
  end;
end;

procedure FreeHelp;
begin
  with Application do if HelpFile <> '' then HelpCommand(HELP_QUIT,0);
end;

procedure ShowDemoHelp(const PropName: String; AClass: TClass;
  New, MethodProp, Duplicate: Boolean);
var
  JumpID: String;
begin
  if New then
  begin
    Application.HelpFile := BlueCodeHelp;
    JumpID := LoadStr(SBlueCodeHelpPfx) + PropName;
  end
  else begin
    Application.HelpFile := DelphiHelp;
    JumpID := LoadStr(SDelphiHelpPfx) + PropName;
  end;
  if MethodProp then JumpID := JumpID + LoadStr(SHelpEventSfx)
  else JumpID := JumpID + LoadStr(SHelpPropertySfx);
  if Duplicate then JumpID := JumpID + AClass.ClassName;
  Application.HelpJump(JumpID);
end;

end.
